---
title: Compressed texture formats
slug: Web/API/WebGL_API/Compressed_texture_formats
---
<p>The WebGL API provides methods to use compressed texture formats. These are useful to increase texture detail while limiting the additional video memory necessary. By default, no compressed formats are available: a corresponding compressed texture format extension must first be enabled.</p>

<h2 id="Usage">Usage</h2>

<p>Unless otherwise specified, this article applies to both WebGL 1 and 2 contexts.</p>

<p>If supported, textures can be stored in a compressed format in video memory. This allows for additional detail while limiting the added video memory necessary. Textures are uncompressed on the fly when being accessed by a shader. Note that this advantage doesn't translate to network bandwidth: while the formats are better than uncompressed data, they are in general far worse than standard image formats such as PNG and JPG.</p>

<p>As compressed textures require hardware support, therefore no specific formats are required by WebGL; instead, a context can make different formats available, depending on hardware support. <a href="https://toji.github.io/texture-tester/">This site</a> shows which formats are supported in the used browser.</p>

<p>Usage of compressed formats first requires activating the respective extension with {{domxref("WebGLRenderingContext.getExtension()")}}. If supported, it will return an extension object with constants for the added formats and the formats will also be returned by calls to <code>gl.getParameter(gl.COMPRESSED_TEXTURE_FORMATS)</code>. (E.g. <code>ext.<span class="message-body-wrapper"><span class="message-flex-body"><span class="devtools-monospace message-body">COMPRESSED_RGBA_S3TC_DXT1_EXT</span></span></span></code> for the {{domxref("WEBGL_compressed_texture_s3tc")}} extension.) These can then be used with {{domxref("WebGLRenderingContext.compressedTexImage2D()", "compressedTexImage[23]D")}} or {{domxref("WebGLRenderingContext.compressedTexSubImage2D()", "compressedTexSubImage[23]D")}} instead of <code>texImage2D</code> calls.</p>

<p>Note that WebGL makes no functionality available to compress or decompress textures: they must already be in a compressed format and can then be directly uploaded to video memory.</p>

<p>All formats support 2D textures. Which formats support <code>TEXTURE_2D_ARRAY</code> and <code>TEXTURE_3D</code> targets (in combination with <code>compressedTexImage3D</code>) are noted in the following table.</p>

<table class="standard-table">
 <caption>Compressed texture extensions and which targets they support.</caption>
 <thead>
  <tr>
   <th scope="col">Extension</th>
   <th scope="col">Notes</th>
   <th scope="col">TEXTURE_2D_ARRAY</th>
   <th scope="col">TEXTURE_3D</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>WEBGL_compressed_texture_astc</td>
   <td> </td>
   <td>Yes</td>
   <td>Yes</td>
  </tr>
  <tr>
   <td>WEBGL_compressed_texture_atc</td>
   <td>Not usable with compressedTexSubImage2D/copyTexSubImage2D.</td>
   <td>No</td>
   <td>No</td>
  </tr>
  <tr>
   <td>WEBGL_compressed_texture_etc</td>
   <td> </td>
   <td>Yes</td>
   <td>No</td>
  </tr>
  <tr>
   <td>WEBGL_compressed_texture_etc1*</td>
   <td>Not usable with compressedTexSubImage2D/copyTexSubImage2D.</td>
   <td>No</td>
   <td>No</td>
  </tr>
  <tr>
   <td>WEBGL_compressed_texture_pvrtc</td>
   <td>Width and height must be powers of 2.</td>
   <td>No</td>
   <td>No</td>
  </tr>
  <tr>
   <td>WEBGL_compressed_texture_s3tc</td>
   <td>Width and height must be multiples of 4.</td>
   <td>Yes</td>
   <td>No</td>
  </tr>
  <tr>
   <td>WEBGL_compressed_texture_s3tc_srgb</td>
   <td>Width and height must be multiples of 4.</td>
   <td>?</td>
   <td>No</td>
  </tr>
 </tbody>
</table>


<h2 id="Examples">Examples</h2>

<pre class="brush: js">async function getCompressedTextureIfAvailable(gl) {
  const texture = gl.createTexture();
  gl.bindTexture(gl.TEXTURE_2D, texture); // create texture object on GPU
  const ext = gl.getExtension('WEBGL_compressed_texture_s3tc'); // will be null if not supported
  if (ext) {
    // the file is already in the correct compressed format
    const dataArrayBuffer = await fetch('/textures/foobar512x512.<span class="message-body-wrapper"><span class="message-flex-body"><span class="devtools-monospace message-body">RGBA_S3TC_DXT1</span></span></span>')
      .then(response =&gt; response.arrayBuffer());
    gl.compressedTexImage2D(gl.TEXTURE_2D,
      0, // set the base image level
      <span class="message-body-wrapper"><span class="message-flex-body"><span class="devtools-monospace message-body">ext.COMPRESSED_RGBA_S3TC_DXT1_EXT</span></span></span>, // the compressed format we are using
      512, 512, // width, height of the image
      0, // border, always 0
      new DataView(dataArrayBuffer));
    gl.generateMipMap(); // create mipmap levels, like we would for a standard image
    return texture;
  }
}</pre>
